## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 8;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           wsl-setup
Version:        1.0.0
Release:        %autorelease
Summary:        Windows Subsystem for Linux setup script and configuration
License:        MIT
URL:            https://src.fedoraproject.org/rpms/wsl-setup
BuildArch:      noarch

Source1:        LICENSE
Source2:        wsl.conf
Source3:        wsl-distribution.conf
Source4:        wsl-oobe.sh
Source5:        firstboot-override.conf
Source6:        wsl-setup-tmpfiles.conf
Source7:        wsl-setup-user-tmpfiles.conf

BuildRequires:  systemd-rpm-macros

# Needed for the distribution icon
Requires:       system-logos


%description
Provides WSL specific configuration files and first-time setup script.


%prep


%build


%install
install -pm 0644 %{SOURCE1} LICENSE
install -Dpm0644 -t %{buildroot}%{_sysconfdir}/ %{SOURCE2}
install -Dpm0644 -t %{buildroot}%{_prefix}/lib/ %{SOURCE3}
install -Dpm0755 -T %{SOURCE4} %{buildroot}%{_libexecdir}/wsl/oobe.sh
ln -s ..%{_prefix}/lib/wsl-distribution.conf %{buildroot}%{_sysconfdir}/wsl-distribution.conf

# WSL provides a socket for x11, but we need to ensure its linked to in /tmp.
# The official recommendation is to disable tmpfiles entirely, but it would be
# nice to work with it, instead.
# https://learn.microsoft.com/en-us/windows/wsl/build-custom-distro#systemd-recommendations
install -Dpm0644 %{SOURCE6} %{buildroot}%{_tmpfilesdir}/%{name}.conf

# WSL provides a Wayland and PulseAudio socket as well, which are expected to be in
# the user's runtime directory. This configuration sets up the links for each user.
install -Dpm0644 %{SOURCE7} %{buildroot}%{_user_tmpfilesdir}/%{name}.conf

# Currently systemd-firstboot hangs forever attempting to acquire the console; this is
# problematic since many other services wait for it to complete before starting, including
# things like the system D-Bus. Configure it to not run in WSL (a preset didn't seem to work)
# until we can see about adjusting either WSL or systemd to make it behave.
install -Dpm0644 %{SOURCE5} %{buildroot}%{_unitdir}/systemd-firstboot.service.d/override.conf


%post
# generate the "auto" naming
. %{_sysconfdir}/os-release
DYNAMIC_NAME="${NAME// /}-${VERSION_ID%.*}"
sed -i "s,DEFAULT_NAME,${DYNAMIC_NAME}," %{_sysconfdir}/wsl-distribution.conf


%files
%config(noreplace) %{_sysconfdir}/wsl.conf
%{_prefix}/lib/wsl-distribution.conf
%{_sysconfdir}/wsl-distribution.conf
%{_libexecdir}/wsl/oobe.sh
%{_tmpfilesdir}/%{name}.conf
%{_user_tmpfilesdir}/%{name}.conf
%{_unitdir}/systemd-firstboot.service.d/override.conf
%license LICENSE


%changelog
## START: Generated by rpmautospec
* Tue Apr 15 2025 Troy Dawson <tdawson@redhat.com> - 1.0.0-8
- Dynamically set DefaultName on package install

* Fri Apr 11 2025 Troy Dawson <tdawson@redhat.com> - 1.0.0-7
- Expand variations for default_name

* Fri Mar 21 2025 Jeremy Cline <jeremycline@linux.microsoft.com> - 1.0.0-6
- Add distribution icon to wsl-distribution.conf

* Sun Feb 23 2025 David Senoner <seda18@rolmail.net> - 1.0.0-5
- fix typo

* Tue Feb 18 2025 Jeremy Cline <jeremycline@linux.microsoft.com> - 1.0.0-4
- oobe: Let the user know they're in wheel and have passwordless sudo

* Fri Jan 31 2025 Jeremy Cline <jeremycline@linux.microsoft.com> - 1.0.0-3
- Add tmpfiles configuration for x11, Wayland, and PulseAudio support

* Tue Jan 28 2025 Jeremy Cline <jeremycline@linux.microsoft.com> - 1.0.0-2
- Replace define macro with global

* Mon Jan 27 2025 Jeremy Cline <jeremycline@linux.microsoft.com> - 1.0.0-1
- Initial import (rhbz #2342289)
## END: Generated by rpmautospec
